<?php

/**
 * Photo Spot Module
 *
 * @version 1.0
 * @author Creative Pulse
 * @copyright Creative Pulse 2009
 * @license GNU/GPLv2
 * @link http://www.creativepulse.eu
 */

// no direct access
defined('_JEXEC') or die('Restricted access');

$show_gallery_filename = JPATH_SITE . '/components/com_photospot/show_gallery.php';
if (!file_exists($show_gallery_filename)) {
	echo JText::_('Photo Spot component is missing');
	return;
}

function get_option($key, $default) {
	$db =& JFactory::getDBO();
	$db->setQuery("SELECT `value` FROM #__photospot_misc WHERE `key` = " . $db->Quote($key));
	$result = $db->loadResult();
	return empty($result) ? $default : $result;
}

$gallery = null;

$db =& JFactory::getDBO();
$user =& JFactory::getUser();
$aid = (int) $user->get('aid', 0);

$access = $params->get('access');
if ($access != 'default' && $aid < intval($access)) {
	$error_msg = get_option('error_msg_unauthorized', 'You are not authorized to access this gallery');
	echo JText::_($error_msg);
	return;
}

// load gallery from the menu parameter gallery id
$handle = trim($params->get('gid', ''));
if ($handle != '' && $handle != '0') {
	$db->setQuery("SELECT * FROM #__photospot_galleries WHERE id = " . intval($handle));
	$gallery = $db->loadObject();

	if ($gallery === null) {
		echo JText::_('Gallery not found');
		return;
	}
}

// load gallery from the menu parameter gallery name
if ($gallery === null) {
	$handle = trim($params->get('gname', ''));
	if ($handle != '') {
		$db->setQuery("SELECT * FROM #__photospot_galleries WHERE name = " . $db->Quote($handle));
		$gallery = $db->loadObject();

		if ($gallery === null) {
			echo JText::_('Gallery not found');
			return;
		}
	}
}


// check for gallery availability
if ($gallery !== null && $gallery->published == '0') {
	$error_msg = get_option('error_msg_unpublished_gallery', 'Gallery is unavailable');
	JError::raiseWarning($error_msg, JText::_($error_msg));
	return;
}


// check for access restrictions from the gallery
if ($gallery !== null && $aid < intval($gallery->access)) {
	$error_msg = get_option('error_msg_unauthorized', 'You are not authorized to access this gallery');
	JError::raiseWarning($error_msg, JText::_($error_msg));
	return;
}


$datasource_name = '';
$viewer_name = '';
$gds = JRequest::getCmd('gds');
$gvw = JRequest::getCmd('gvw');

$datasource_permissions = $params->get('datasource_permissions');
$viewer_permissions = $params->get('viewer_permissions');
if ($gallery !== null) {
	$gallery_params = new JParameter($gallery->params);

	if ($datasource_permissions == 'default')
		$datasource_permissions = $gallery_params->get('datasource_permissions', '');

	if ($viewer_permissions == 'default')
		$viewer_permissions = $gallery_params->get('viewer_permissions', '');
}


if ($gds != '' && $gvw != '' && $params->get('gallery_from_url') == '1') {
	// load datasource and viewer from the URL
	$datasource_name = $gds;
	$datasource_permissions = 'allow_all';
	$viewer_name = $gvw;
	$viewer_permissions = 'allow_all';
}
else {
	$mod_datasource_name = trim($params->get('datasource_name', ''));
	$mod_viewer_name = trim($params->get('viewer_name', ''));

	if ($gds != '' && $datasource_permissions == 'allow_all')
		$datasource_name = $gds;
	else if ($mod_datasource_name != '')
		$datasource_name = $mod_datasource_name;
	else if ($gallery !== null)
		$datasource_name = $gallery->datasource;

	if ($gvw != '' && $viewer_permissions == 'allow_all')
		$viewer_name = $gvw;
	else if ($mod_viewer_name != '')
		$viewer_name = $mod_viewer_name;
	else if ($gallery !== null)
		$viewer_name = $gallery->viewer;
}

if ($datasource_name == '' || $viewer_name == '') {
	JError::raiseWarning('Missing gallery information', JText::_('Missing gallery information'));
	return;
}

if ($gallery !== null) {
	$datasource_params = new JParameter($gallery->datasource_params);
	$viewer_params = new JParameter($gallery->viewer_params);
}
else {
	$datasource_params = new JParameter('');
	$viewer_params = new JParameter('');
}

$p = new JParameter($params->get('datasource_params', ''));
$datasource_params->merge($p);

$p = new JParameter($params->get('viewer_params', ''));
$viewer_params->merge($p);

if ($datasource_permissions == 'allow_params' || $datasource_permissions == 'allow_all')
	foreach ($_GET as $k => $v)
		$datasource_params->set($k, $v);

if ($viewer_permissions == 'allow_params' || $viewer_permissions == 'allow_all')
	foreach ($_GET as $k => $v)
		$viewer_params->set($k, $v);


require($show_gallery_filename);

?>